/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.vliw.PE;
import ru.ispras.microtesk.model.vliw.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

public final class BFT extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "BFT",
          BFT.class,
          null
          );
      addArgument("cc", COND_CODE);
      addArgument("offset", SHORT);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate cc = (Immediate) getArgument("cc", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new BFT(cc, offset);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate cc;
  public final Immediate offset;

  public BFT(final Immediate cc, final Immediate offset) {
    assert COND_CODE.equals(cc.getType());
    assert SHORT.equals(offset.getType());

    this.cc = cc;
    this.offset = offset;

    addArgument("cc", cc);
    addArgument("offset", offset);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("BFT %d, <label>%d", cc.access().load().bigIntegerValue(), offset.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("01000101000%s01%s", cc.access().load().toString(), offset.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    if (pe__.FCCR.access().bitField(cc.access().load(), cc.access().load()).load().equals(Data.valueOf(Type.INT(1), 0x1))) {
      vars__.BRANCH.access().store(Data.valueOf(BIT, 0x1));
      vars__.JMPADDR.access().store(vars__.NIA.access().load().add(Data.signExtend(WORD, offset.access().load()).shiftLeft(Data.valueOf(WORD, 0x3))));
    }
  }
}